Fixed the interaction of --fake-super with --link-dest & --xattrs.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
fc29efc3
WD
26# For itemized output:
27all_plus='+++++++++'
28allspace=' '
29dots='.....' # trailing dots after changes
30
2094283b 31# Berkley's nice.
96553aa7 32PATH="$PATH:/usr/ucb"
2094283b 33
e3442095 34if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
35 diffopt="-u"
36else
37 diffopt="-c"
38fi
39
a98cad00
WD
40HOME="$scratchdir"
41export HOME
42
3a4c683f
MP
43runtest() {
44 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
45 if eval "$2"
46 then
6f481bb0 47 echo "$ECHO_T done."
501972bf
MP
48 return 0
49 else
6f481bb0 50 echo "$ECHO_T failed!"
501972bf
MP
51 return 1
52 fi
3a4c683f
MP
53}
54
757287d8
WD
55# Call this if you want to filter out verbose messages (-v or -vv) from
56# the output of an rsync run (whittling the output down to just the file
57# messages). This isn't needed if you use -i without -v.
58filter_outfile() {
59 sed -e '/^building file list /d' \
9544261a 60 -e '/^sending incremental file list/d' \
757287d8
WD
61 -e '/^created directory /d' \
62 -e '/^done$/d' \
63 -e '/ --whole-file$/d' \
64 -e '/^total: /d' \
332cf6df
WD
65 -e '/^client charset: /d' \
66 -e '/^server charset: /d' \
757287d8
WD
67 -e '/^$/,$d' \
68 <"$outfile" >"$outfile.new"
69 mv "$outfile.new" "$outfile"
70}
71
3a4c683f
MP
72printmsg() {
73 echo "$1"
74}
75
6773a779 76rsync_ls_lR() {
db9c9e27 77 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
dfef3f10
MP
78}
79
18d7e9f4 80check_perms() {
eace352b
WD
81 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
82 if test $perms = $2; then
83 return 0
84 fi
85 echo "permissions: $perms on $1"
86 echo "should be: $2"
87 test_fail "failed test $3"
18d7e9f4
WD
88}
89
dfef3f10
MP
90rsync_getgroups() {
91 "$TOOLDIR/getgroups"
57835c00
MP
92}
93
94
e052b21f 95####################
6f481bb0 96# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 97
3a4c683f 98hands_setup() {
501972bf 99 # Clean before creation
6f481bb0
WD
100 rm -rf "$fromdir"
101 rm -rf "$todir"
3d807132 102
e3442095
WD
103 [ -d "$tmpdir" ] || mkdir "$tmpdir"
104 [ -d "$fromdir" ] || mkdir "$fromdir"
105 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 106
e052b21f
MP
107 # On some BSD systems, the umask affects the mode of created
108 # symlinks, even though the mode apparently has no effect on how
109 # the links behave in the future, and it cannot be changed using
110 # chmod! rsync always sets its umask to 000 so that it can
111 # accurately recreate permissions, but this script is probably run
112 # with a different umask.
113
114 # This causes a little problem that "ls -l" of the two will not be
115 # the same. So, we need to set our umask before doing any creations.
116
3a4c683f 117 # set up test data
6f481bb0
WD
118 touch "$fromdir/empty"
119 mkdir "$fromdir/emptydir"
e8ca5901 120
571a4b26 121 # a hundred lines of text or so
6f481bb0 122 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 123
6f481bb0 124 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 125 umask 0
6f481bb0 126 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 127 umask 022
0154b302 128
db10766a 129 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
130 mkdir "$fromdir/dir"
131 cp "$fromdir/text" "$fromdir/dir"
132 mkdir "$fromdir/dir/subdir"
133 echo some data > "$fromdir/dir/subdir/foobar.baz"
134 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
135 if [ -r /etc ]; then
136 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
137 else
138 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
139 fi
6f481bb0 140 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
141 if [ -r /bin ]; then
142 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
143 else
144 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
145 fi
7d691654 146
8f98c608 147# echo testing head:
6f481bb0 148# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 149}
3fedd74b
MP
150
151
99cdaff7
MP
152####################
153# Many machines do not have "mkdir -p", so we have to build up long paths.
154# How boring.
5ef8c5c6 155makepath() {
d1798a2f
WD
156 for p in "${@}"; do
157 (echo " makepath $p"
158
99cdaff7
MP
159 # Absolut Unix.
160 if echo $p | grep '^/' >/dev/null
161 then
162 cd /
163 fi
164
d1798a2f 165 # This will break if $p contains a space.
99cdaff7
MP
166 for c in `echo $p | tr '/' ' '`
167 do
112e7311
MP
168 if [ -d "$c" ] || mkdir "$c"
169 then
170 cd "$c" || return $?
171 else
172 echo "failed to create $c" >&2; return $?
173 fi
d1798a2f
WD
174 done)
175 done
99cdaff7
MP
176}
177
178
179
3fedd74b
MP
180###########################
181# Run a test (in '$1') then compare directories $2 and $3 to see if
182# there are any difference. If there are, explain them.
183
f494f286
MP
184# So normally basically $1 should be an rsync command, and $2 and $3
185# the source and destination directories. This is only good when you
186# expect to transfer the whole directory exactly as is. If some files
187# should be excluded, you might need to use something else.
188
3fedd74b 189checkit() {
3fedd74b 190 failed=
3fedd74b 191
cf72f204
MP
192 # We can just write everything to stdout/stderr, because the
193 # wrapper hides it unless there is a problem.
194
195 echo "Running: \"$1\""
196 eval "$1"
3fedd74b
MP
197 status=$?
198 if [ $status != 0 ]; then
199 failed="YES";
200 fi
201
cf72f204
MP
202 echo "-------------"
203 echo "check how the directory listings compare with diff:"
204 echo ""
6f481bb0
WD
205 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
206 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
207 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
208
209 echo "-------------"
210 echo "check how the files compare with diff:"
211 echo ""
212 if [ "x$4" != x ]; then
213 echo " === Skipping (as directed) ==="
214 else
215 diff -r $diffopt "$2" "$3" || failed=YES
216 fi
217
218 echo "-------------"
6f481bb0 219 if [ -z "$failed" ] ; then
3fedd74b
MP
220 return 0
221 else
3fedd74b
MP
222 return 1
223 fi
224}
225
863dff51 226
4a7cb3e8 227build_rsyncd_conf() {
d2094cc3
MP
228 # Build an appropriate configuration file
229 conf="$scratchdir/test-rsyncd.conf"
230 echo "building configuration $conf"
231
232 port=2612
233 pidfile="$scratchdir/rsyncd.pid"
234 logfile="$scratchdir/rsyncd.log"
e5255195 235 hostname=`uname -n`
d2094cc3 236
6f481bb0 237 cat >"$conf" <<EOF
3aae15ec 238# rsyncd configuration file autogenerated by $0
d2094cc3 239
3aae15ec
MP
240pid file = $pidfile
241use chroot = no
9585b276 242munge symlinks = no
e73eed85 243hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
3aae15ec 244log file = $logfile
2ae4126a
WD
245log format = %i %h [%a] %m (%u) %l %f%L
246transfer logging = yes
6f481bb0 247exclude = foobar.baz
eddeaf76 248max verbosity = 9
76ee1d18
WD
249uid = 0
250gid = 0
98c1b325 251
2e6c7f45 252[test-from]
6f481bb0 253 path = $fromdir
3aae15ec 254 read only = yes
d2094cc3 255
2e6c7f45 256[test-to]
6f481bb0 257 path = $todir
3aae15ec 258 read only = no
2ae4126a
WD
259
260[test-scratch]
261 path = $scratchdir
262 read only = no
d2094cc3 263EOF
2d8f9b1d
WD
264
265 # Build a helper script to ignore exit code 23
266 ignore23="$scratchdir/ignore23"
267 echo "building help script $ignore23"
268
269 cat >"$ignore23" <<'EOT'
270if "${@}"; then
271 exit
272fi
273
274ret=$?
275
276if test $ret = 23; then
277 exit
278fi
279
280exit $ret
281EOT
282chmod +x "$ignore23"
d2094cc3
MP
283}
284
285
3cd2af41 286build_symlinks() {
3cd2af41
MP
287 mkdir "$fromdir"
288 date >"$fromdir/referent"
289 ln -s referent "$fromdir/relative"
290 ln -s "$fromdir/referent" "$fromdir/absolute"
291 ln -s nonexistent "$fromdir/dangling"
1db8b61d 292 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
293}
294
295test_fail() {
296 echo "$@" >&2
297 exit 1
298}
299
a217ad30
MP
300test_skipped() {
301 echo "$@" >&2
6f481bb0 302 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
303 exit 77
304}
305
be2f866b
MP
306# It failed, but we expected that. don't dump out error logs,
307# because most users won't want to see them. But do leave
308# the working directory around.
309test_xfail() {
310 echo "$@" >&2
311 exit 78
312}
313
d1239eae
MP
314# Determine what shell command will appropriately test for links.
315ln -s foo "$scratchdir/testlink"
316for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
317do
318 for switch in -h -L
319 do
320 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
321 then
322 # how nice
323 TEST_SYMLINK_CMD="$cmd $switch"
324 # i wonder if break 2 is portable?
325 break 2
326 fi
327 done
328done
cca4e067
MP
329# ok, now get rid of it
330rm "$scratchdir/testlink"
d1239eae
MP
331
332
333if [ "x$TEST_SYMLINK_CMD" = 'x' ]
334then
335 test_fail "Couldn't determine how to test for symlinks"
336else
337 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
338fi
339
340
d96d3893
MP
341# Test whether something is a link, allowing for shell peculiarities
342is_a_link() {
d1239eae
MP
343 # note the variable contains the first option and therefore is not quoted
344 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
345}
346
77867907
MP
347
348# We need to set the umask to be reproducible. Note also that when we
349# do some daemon tests as root, we will setuid() and therefore the
350# directory has to be writable by the nobody user in some cases. The
351# best thing is probably to explicitly chmod those directories after
352# creation.
353
ad301e48 354umask 022